# TTMAC_Base Class Reference

`#include <ttmac.h>`

Inheritance diagram for TTMAC_Base:

List of all members.

## Detailed Description

_

Definition at line 12 of file ttmac.h.

## Public Types
typedef T_Endianness | ByteOrderClass
typedef T_HashWordType | HashWordType
## Public Member Functions
unsigned int | DigestSize () const
void | UncheckedSetKey (const byte *userKey, unsigned int keylength, const NameValuePairs &params)
void | TruncatedFinal (byte *mac, size_t size)
unsigned int | BlockSize () const
ByteOrder | GetByteOrder () const
unsigned int | OptimalBlockSize () const
unsigned int | OptimalDataAlignment () const
void | Update (const byte *input, size_t length)
byte * | CreateUpdateSpace (size_t &size)
void | Restart ()
## Static Public Member Functions
static std::string | StaticAlgorithmName ()
static size_t __cdecl | StaticGetValidKeyLength (size_t)
static void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)
## Static Public Attributes
static const int | DIGESTSIZE = 20
static const int | KEYLENGTH
static const int | MIN_KEYLENGTH
static const int | MAX_KEYLENGTH
static const int | DEFAULT_KEYLENGTH
static const int | IV_REQUIREMENT
static const int | IV_LENGTH
static const int | BLOCKSIZE = T_BlockSize
static CompileAssert <((T_BlockSize &(T_BlockSize-1))==0)> | cryptopp_assert___LINE__
## Protected Member Functions
void | HashEndianCorrectedBlock (const word32 *data)
void | Init ()
word32 * | StateBuf ()
T_HashWordType * | DataBuf ()
T_HashWordType | GetBitCountHi () const
T_HashWordType | GetBitCountLo () const
void | PadLastBlock (unsigned int lastBlockSize, byte padFirst=0x80)
virtual void | HashEndianCorrectedBlock (const HashWordType *data)=0
virtual size_t | HashMultipleBlocks (const T_HashWordType *input, size_t length)
void | HashBlock (const HashWordType *input)
## Static Protected Member Functions
static void | Transform (word32 *digest, const word32 *X, bool last)
## Protected Attributes
FixedSizeSecBlock< word32, 10 > | m_digest
FixedSizeSecBlock< word32, 5 > | m_key
FixedSizeSecBlock < T_HashWordType, T_BlockSize/sizeof(T_HashWordType)> | m_data

The documentation for this class was generated from the following files:

- ttmac.h
- ttmac.cpp